#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter_administration.cgi,v 0.00.0.1 2013/05/07 ShelbyGT500
#

# Add entry in menu
# MENUENTRY copfilter 130 "Administration" "copfilter menu_administration"
#
# Make sure translation exists $Lang::tr{'copfilter menu_administration'}


use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $restoremessage = '';
$copfiltersettings{'ACTION'} = '';
$copfiltersettings{'UPDATEFILE'}='';



my %mainsettings = ();
&General::readhash('/var/ipcop/main/settings', \%mainsettings);


$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&General::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


#&Header::showhttpheaders();
#&Header::openpage('Copfilter', 1, '');




################################################################################
##   Substitutions
################################################################################




################################################################################
##   ACTIONs
################################################################################


##########################   Back up    ###############


#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
#&Header::getcgihash(\%copfiltersettings);
&General::getcgihash(\%copfiltersettings);
use File::Copy;


	if ($copfiltersettings{'ACTION'} eq 'COPFILTER V2 ---> [ . ]')	

#	if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter admin_create new backup'})
	{
		
		
		mkdir("/tmp/backup");
#		system("tar -czf '/tmp/backup/copfilterV2-backup.tar.gz' '${copfilter_swroot}/opt/backup/valid' '${copfilter_swroot}/opt/havp/etc/blacklist' '${copfilter_swroot}/opt/havp/etc/whitelist' '${copfilter_swroot}/etc' '${copfilter_swroot}/opt/c_icap/etc/urlscanexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/avscansourceexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/allowdomains.txt' '${copfilter_swroot}/opt/c_icap/etc/denydomains.txt' '${copfilter_swroot}/opt/c_icap/etc/avscanexceptions.txt'"); 

		`tar -czf '/tmp/backup/copfilterV2-backup.tar.gz' '${copfilter_swroot}/opt/backup/valid' '${copfilter_swroot}/opt/havp/etc/blacklist' '${copfilter_swroot}/opt/havp/etc/whitelist' '${copfilter_swroot}/etc' '${copfilter_swroot}/opt/c_icap/etc/urlscanexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/avscansourceexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/allowdomains.txt' '${copfilter_swroot}/opt/c_icap/etc/denydomains.txt' '${copfilter_swroot}/opt/c_icap/etc/avscanexceptions.txt'`; 



			print "Content-type: application/gzip\n";
			print "Content-length: ";

			print (-s "/tmp/backup/copfilterV2-backup.tar.gz");

			print "\n";
			print "Content-disposition: attachment; filename=copfilterV2-backup.tar.gz\n\n";
			open (FILE, "/tmp/backup/copfilterV2-backup.tar.gz");

			while (<FILE>) { print; }
			close (FILE);



			exit;

		
	}

##########################   Restore    ###############

	if ($copfiltersettings{'ACTION'} eq '[ . ] ---> COPFILTER V2')
	{
		&General::getcgihash(\%copfiltersettings, {'wantfile' => 1, 'filevar' => 'UPDATEFILE'});


		if (!($copfiltersettings{'UPDATEFILE'} =~ /.tar.gz$/))
		{


#			$errormessage = $Lang::tr{'copfilter admin_invalid restore file'};
			$errormessage = $Lang::tr{'save error'};
#			$errormessage = 'INVALID RESTORE FILE ! ';


			print "$errormessage";

		}
		else
		{
			#sub copfilter_set_lang {


			$restoremessage = 'Changes will take effect within 5 minutes...';
			print "$restoremessage";

		}

	
		mkdir("/tmp/restore");
		copy($copfiltersettings{'UPDATEFILE'},"/tmp/restore/restore.tar.gz");
		system("/bin/tar --no-same-owner --preserve-permissions -xzf /tmp/restore/restore.tar.gz -C /tmp/restore");
			
	}








################################################################################
##   set update values
################################################################################






################################################################################
##   purge enable and update files
################################################################################




################################################################################
##  ERROR/RESTORE MESSAGE - DON'T MOVE HEADER TO PREVENT ISSUES
################################################################################



#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');
&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
#    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    &Header::closebox();
}


if ($restoremessage) {
    &Header::openbox('100%', 'left',$Lang::tr{'backup'});

    #print "<class name='base'><font color='${Header::colourred}'>$restoremessage\n</font>";
    print "<font class='base'>$restoremessage&nbsp;</font>\n";
    &Header::closebox();
}




################################################################################
##   Use langs files -DON'T MOVE TO PREVENT ISSUES 
################################################################################

#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();





################################################################################
##  Website ADMINISTRATION
################################################################################


print "<a name='Administration'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter menu_administration'} ");


#print "<form method='post' action='/cgi-bin/copfilter_administration.cgi' enctype='multipart/form-data'>";
print "<form method='post' action='$ENV{'SCRIPT_NAME'}' enctype='multipart/form-data'>\n";



print <<END



<table width='100%'>
<img src='/images/floppy.gif' >
<tr>
	<td colspan='4' class='base'><b>$Lang::tr{'copfilter admin_backup settings'}</b></td>
</tr>
<tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>
</tr>
<tr>
	<td colspan='4' class='base'><input type='submit' name='ACTION' value='COPFILTER V2 ---> [ . ]' />&nbsp; $Lang::tr{'copfilter admin_create new backup'}
</td>
</tr>
<tr>&nbsp; </tr>
<br />

</table>

<br />
<br />



<hr size='1'>

<table width='100%'>
</tr>
<img src='/images/reload.gif' >
<tr>&nbsp; </tr>
<br />

<tr>
	<td class='base'><b>$Lang::tr{'copfilter admin_restore settings'}</b></td>
</tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>

<tr>
	<td>$Lang::tr{'copfilter admin_restore text'}:***</td>
</tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>

<tr>
	<td><input type='file' name='UPDATEFILE' size='40' /> &nbsp; <input type='submit' name='ACTION' value='[ . ] ---> COPFILTER V2' />&nbsp; $Lang::tr{'copfilter admin_import'}</td>

</tr>
</tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>

<tr>

<td>$Lang::tr{'copfilter clamd thrdp_info'}</td>
<td nowrap colspan='2' nowrap> <b><font size='0.5em'>Admin mod version : $copfiltersettings{'ADMIN_VERSION'}<br> </b></td>
</table>
<br />
		

<br />
	<td nowrap valign='bottom' align='right'><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>

</form>


END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";

# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


